/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: TaxonomyConcept.java,v 584a8002bbf7 2010/07/17 13:10:42 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.taxonomy;

import it.tidalwave.util.As;
import it.tidalwave.util.Displayable;
import it.tidalwave.util.NotFoundException;
import javax.annotation.Nonnull;
import org.openide.util.Lookup;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: TaxonomyConcept.java,v 584a8002bbf7 2010/07/17 13:10:42 fabrizio $
 *
 **********************************************************************************************************************/
public interface TaxonomyConcept extends Displayable, Lookup.Provider, As
  {
    /*******************************************************************************************************************
     *
     * Creates a sub concept.
     *
     * @param  displayName  the display name
     * @param  id           the id
     * @return              the sub concept
     *
     ******************************************************************************************************************/
    @Nonnull
    public TaxonomyConcept createSubConcept (@Nonnull String displayName,
                                             @Nonnull String id);

    /*******************************************************************************************************************
     *
     * Finds the sub concepts of this object.
     *
     * @return  a {@link Finder} of sub concepts
     *
     ******************************************************************************************************************/
    @Nonnull
    public Finder<TaxonomyConcept> findSubConcepts();

    /*******************************************************************************************************************
     *
     * Sets an {@link AnonymousTaxon} to be synonym to this object.
     *
     * @return  a {@link Finder} of sub concepts
     *
     ******************************************************************************************************************/
    public void setAnonymousSynonym (@Nonnull AnonymousTaxon synonym);

    /*******************************************************************************************************************
     *
     * Return the {@link AnonymousTaxon} which is synonym to this object.
     *
     * @return  the synonym
     * @throws  NotFoundException  if no synonym
     *
     ******************************************************************************************************************/
    @Nonnull
    public AnonymousTaxon getAnonymousSynonym()
      throws NotFoundException;

    @Nonnull
    // FIXME: return a Set<TaxonomyConcept>
    // FIXME: what about returning a Finder?
    public Object getSynonyms();
  }
